
// WrapAnimTour3D.java
// Andrew Davison, April 2005, ad@fivedots.coe.psu.ac.th

/* Obvyklá svět s šachovnicí, ovšem nyní s animovaným 3D-spritem.
*/

import javax.swing.*;
import java.awt.*;
import java.io.*;

import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.behaviors.vp.*;
import com.sun.j3d.utils.image.TextureLoader;

// import com.tornadolabs.j3dtree.*;    // pro zobrazení grafu scény


public class WrapAnimTour3D extends JPanel
// Uchovává 3D-canvas, na němž se zobrazuje načtený obrázek
{
  private static final int PWIDTH = 512;   // velikost panelu
  private static final int PHEIGHT = 512; 

  private SimpleUniverse su;
  private BranchGroup sceneBG;
  private BoundingSphere bounds;   // pro uzly prostředí

  // private Java3dTree j3dTree;   // okno pro zobrazení stromové struktury


  public WrapAnimTour3D()
  // vytvoří 3D-canvas
  {
    setLayout( new BorderLayout() );
    setOpaque( false );
    setPreferredSize( new Dimension(PWIDTH, PHEIGHT));

    GraphicsConfiguration config =
					SimpleUniverse.getPreferredConfiguration();
    Canvas3D canvas3D = new Canvas3D(config);
    add("Center", canvas3D);
    canvas3D.setFocusable(true);
    canvas3D.requestFocus();
    su = new SimpleUniverse(canvas3D);

    // j3dTree = new Java3dTree();   // vytvoř zobrazovací strom pro SG

    createSceneGraph();
    su.addBranchGraph( sceneBG );

	// j3dTree.updateNodes( su );    // sestav okno pro zobrazení stromu
  } // konec konstruktoru: WrapAnimTour3D()


  private void createSceneGraph() 
  // inicializuje scénu
  { sceneBG = new BranchGroup();
    bounds = new BoundingSphere(new Point3d(0,0,0), 100); 

    lightScene();         // přidej světla
    addBackground();      // přidej oblohu
    sceneBG.addChild( new CheckerFloor().getBG() );  // přidej podlahu

    addTourist();         // přidej uživatelem ovládaný animovaný 3D-sprite

	// j3dTree.recursiveApplyCapability( sceneBG );   // nastav vlastnosti zobrazení stromu

    sceneBG.compile();   // zafixuj scénu
  } // konec metody: createSceneGraph()



  private void lightScene()
  /* Jedno ambientní světlo, 2 směrová světla */
  {
    Color3f white = new Color3f(1.0f, 1.0f, 1.0f);

    // připrav ambientní světlo
    AmbientLight ambientLightNode = new AmbientLight(white);
    ambientLightNode.setInfluencingBounds(bounds);
    sceneBG.addChild(ambientLightNode);

    // připrav směrová světla
    Vector3f light1Direction  = new Vector3f(-1.0f, -1.0f, -1.0f);
       // vlevo, dolů, dozadu 
    Vector3f light2Direction  = new Vector3f(1.0f, -1.0f, 1.0f);
       // vpravo, dolů, dopředu

    DirectionalLight light1 = 
            new DirectionalLight(white, light1Direction);
    light1.setInfluencingBounds(bounds);
    sceneBG.addChild(light1);

    DirectionalLight light2 = 
        new DirectionalLight(white, light2Direction);
    light2.setInfluencingBounds(bounds);
    sceneBG.addChild(light2);
  }  // konec metody: lightScene()



  private void addBackground()
  // modrou obhlohu s mraky vytvoříme pomocí škálované textury
  {
    TextureLoader bgTexture = new TextureLoader("models/bigSky.jpg", null);
	Background back = new Background(bgTexture.getImage());
    back.setImageScaleMode(Background.SCALE_FIT_MAX);
    // back.setImageScaleMode(Background.SCALE_REPEAT);   // dlaždicový přístup
    back.setApplicationBounds( bounds );

    sceneBG.addChild( back );
  } // konec metody: addBackground()



  // --------------------- turista ---------------------------


  private void addTourist()
  /*  Turista (bob) je reprezentován několika modely pomocí objektů
      typu AnimSprite3D.

      Vstup klávesnice zachytává objekt typu KeyBehavior a předává jej 
      ke zpracování objektu typu Animator.

      Animator přidává animační sekvenci do animačního rozvrhu.
      Animace je na boba aplikována každých 75 ms, a obvykle sestává
      ze změny pozice a vzhledu.
  */
  { // sprite
    AnimSprite3D bob = new AnimSprite3D();
    bob.setPosition(2.0, 1.0);
    sceneBG.addChild( bob.getTG() );

    // uzel TG pro výhled
    ViewingPlatform vp = su.getViewingPlatform();
    TransformGroup viewerTG = vp.getViewPlatformTransform(); 

    // animátor spritu
    Animator animBeh = new Animator(20, bob, viewerTG); 
    animBeh.setSchedulingBounds( bounds );
    sceneBG.addChild( animBeh );

    // vstupní klávesy spritu
    KeyBehavior kb = new KeyBehavior(animBeh); 
    kb.setSchedulingBounds( bounds );
    sceneBG.addChild( kb );
  } // konec metody: addTourist()


  // -------------------------------------------------

  public static void main(String[] args)
  { new AnimTourFS(); }


} // konec třídy: AnimTourFS